"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.login = exports.loginClient = exports.pwHash = exports.logout = exports.reqReadEntities = exports.ensureEntityConf = exports.reqEntityConf = exports.presenceFor = exports.getUnitFromChannel = exports.getChannelAndTypeFromRid = exports.getChannelTypeFromChannel = exports.fromChannel = exports.mailerSend = exports.notificationRead = exports.dataHistoryDelete = exports.dataHistoryRead = exports.dataHistoryCreateBatch = exports.updateUserCredentials = exports.updateUser = exports.updateThingCredentials = exports.updateProfile = exports.updateOwnPassword = exports.updateConfiguration = exports.removeRoleFromThing = exports.removeChildFromAsset = exports.readUser = exports.readRole = exports.readProfile = exports.readConfiguration = exports.readChannelType = exports.readChannel = exports.deleteConfiguration = exports.createConfiguration = exports.addRoleToThing = exports.addConfigurationToEntity = exports.addChildToAsset = exports.req = exports.unsubEntityUpdates = exports.subEntityUpdates = exports.confUpdatesChannel = exports.unsub = exports.sub = exports.pubChannel = exports.pub = exports.ridToBusChannel = void 0;

var _extendedDsClient = _interopRequireWildcard(require("extended-ds-client"));

var _sha = _interopRequireDefault(require("crypto-js/sha256"));

var R = _interopRequireWildcard(require("ramda"));

var _jstiip = _interopRequireDefault(require("jstiip"));

var _subSeconds = _interopRequireDefault(require("date-fns/fp/subSeconds"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

var _dmUtils = require("./dm-utils");

var _transforms = require("./transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * From a rid, get the channel id on the bus
 * @param {string} rid Channel entity rid
 * @returns {string} A bus channel id for channel data
 */
var ridToBusChannel = function ridToBusChannel(rid) {
  return "data/".concat(rid);
};
/**
 * Publishes a message through the backend.
 * @func
 * @static
 * @param {string} channel The channel to publish on.
 * @param {Array} pl The payload to send.
 * @param {string} sig The signal data to apply to the published message.
 */


exports.ridToBusChannel = ridToBusChannel;

var pub = function pub(channel) {
  var pl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var sig = arguments.length > 2 ? arguments[2] : undefined;
  var msg = new _jstiip["default"]({
    pl: pl
  });
  if (sig) msg.sig = sig;
  var msgOut = msg.toJS();

  _extendedDsClient.ds.client.event.emit(channel, msgOut); // console.log('PUB:', channel, msgOut);

};
/**
 * Publishes a message on a channel, and returns a promise.
 * @func
 * @static
 * @param {string} channelRid The rid of the channel to publish on.
 * @param {Array} pl The payload to send.
 * @param {string} sig The signal data to apply to the published message.
 * @returns {Promise} Promisified success/error
 */


exports.pub = pub;

var pubChannel =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(channelRid) {
    var pl,
        sig,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            pl = _args.length > 1 && _args[1] !== undefined ? _args[1] : [];
            sig = _args.length > 2 ? _args[2] : undefined;
            return _context.abrupt("return", pub(ridToBusChannel(channelRid), pl, sig));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function pubChannel(_x) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Low-level subscribe to a channel on the backend. Recommended to use fromChannel instead.
 * @func
 * @static
 * @param {function} callback The callback to trigger when a message arrives.
 * @param {string} channel The channel to subscribe to.
 */


exports.pubChannel = pubChannel;
var sub = R.curry(function (callback, channel) {
  return _extendedDsClient.ds.client.event.subscribe(channel, callback);
});
/**
 * Low-level unsubscribe from a channel on the backend (See fromChannel).
 * @func
 * @static
 * @param  {string} channel - The channel to unsubscribe from.
 * @param  {function} [callback] - The callback that was previously registered with subscribe. If
 *  the callback is omitted, all subscriptions for the channel will be removed.
 */

exports.sub = sub;

var unsub = function unsub(channel, callback) {
  return _extendedDsClient.ds.client.event.unsubscribe(channel, callback);
};
/**
 * [curried] From type & rid, get the channel id for updates on that record
 * @param {string} type Type of entity
 * @param {string} rid Entity rid
 * @returns {string} A bus channel id for entity updates
 */


exports.unsub = unsub;
var confUpdatesChannel = R.curry(function (type, rid) {
  return "conf/".concat(type, "/update/").concat(rid);
});
exports.confUpdatesChannel = confUpdatesChannel;

var subEntityUpdates = function subEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (cb) {
    return R.forEach(R.o(sub(cb), ridToChannel));
  };
};

exports.subEntityUpdates = subEntityUpdates;

var unsubEntityUpdates = function unsubEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (rids, cb) {
    return R.forEach(R.o(function (ch) {
      return unsub(ch, cb);
    }, ridToChannel))(rids);
  };
};
/**
 * Performs a request to the backend.
 * TODO: Refactor temporarily to rids:* to target all, but only for 'conf...'-requests
 * @func
 * @static
 * @param {string} id The id of the rpc
 * @param {object} args Arguments passed on to the rpc
 * @return {Promise} A Promise
 */


exports.unsubEntityUpdates = unsubEntityUpdates;
var req = R.curry(function (id, args) {
  // console.debug('req:', id, args);
  return _extendedDsClient.ds.client.rpc.p.make(id, args)["catch"](function (err) {
    console.error(id, args, err);
    throw err;
  });
}); // === conf ===

/**
 * Adds assets as children to an asset.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the assets to add children to.
 * @param {Array<String>} args.children The record ids of the assets to set as children to the asset.
 * @returns {void}
 */

exports.req = req;
var addChildToAsset = req('conf/addChildToAsset');
/**
 * Adds a configuration to an entity
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the entities to add configurations to.
 * @param {Array<String>} args.configurations The record ids of the configurations to add to the entities.
 * @returns {void}
 */

exports.addChildToAsset = addChildToAsset;
var addConfigurationToEntity = req('conf/addConfigurationToEntity');
/**
 * Adds roles to things.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the things to add roles to.
 * @param {Array<String>} args.roles The record ids of the roles to add.
 * @returns {Number} The number of added roles.
 */

exports.addConfigurationToEntity = addConfigurationToEntity;
var addRoleToThing = req('conf/addRoleToThing');
/**
 * Creates a new configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.id The id to set for the configuration.
 * @param {Object} args.properties The properties to apply to the configuration.
 * @returns {Object} The created configuration record.
 */

exports.addRoleToThing = addRoleToThing;
var createConfiguration = req('conf/createConfiguration');
/**
 * Deletes configurations in the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to delete, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the delete operation.
 * @returns {Number} The number of deleted records.
 */

exports.createConfiguration = createConfiguration;
var deleteConfiguration = req('conf/deleteConfiguration');
/**
 * Reads channels from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @param {Array<String>} args.types The record ids of the channel types to read channels from.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.deleteConfiguration = deleteConfiguration;
var readChannel = req('conf/readChannel');
/**
 * Reads channel types from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readChannel = readChannel;
var readChannelType = req('conf/readChannelType');
/**
 * Reads configurations from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @param {Array<String>} args.entities The record ids of the entities to read configurations for.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readChannelType = readChannelType;
var readConfiguration = req('conf/readConfiguration');
/**
 * Returns the identity record of the requesting client.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @returns {object}
 */

exports.readConfiguration = readConfiguration;
var readProfile = req('conf/readProfile');
/**
 * Reads roles from the configuration.'
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readProfile = readProfile;
var readRole = req('conf/readRole');
/**
 * Reads users from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readRole = readRole;
var readUser = req('conf/readUser');
/**
 * Removes children assets from a parent asset.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the assets to remove children from.
 * @param {Array<String>} args.children  	The record ids of the children assets to remove from the asset.
 * @returns {void}
 */

exports.readUser = readUser;
var removeChildFromAsset = req('conf/removeChildFromAsset');
/**
 * Removes roles from things.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the things to remove roles from.
 * @param {Array<String>} args.roles The record ids of the roles to remove.
 * @returns {Number} The number of removed roles.
 */

exports.removeChildFromAsset = removeChildFromAsset;
var removeRoleFromThing = req('conf/removeRoleFromThing');
/**
 * Updates configurations in the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to update, use [] to target all records.
 * @param {Object} args.properties The properties to apply to the configurations.
 * @param {Array<String>} args.remove The properties to remove from the record.
 * @param {Array} args.filter The filter to apply for the update operation.
 * @param {Number} args.limit The maximum number of records to update.
 * @param {String} args.mode "shallow"
 * @returns {Number} The number of updated records.
 */

exports.removeRoleFromThing = removeRoleFromThing;
var updateConfiguration = req('conf/updateConfiguration');
/**
 * Updates the requesters own password.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.oldPassword The current password of the requesting client.
 * @param {String} args.newPassword The new password to set for the requesting client.
 * @param {Boolean} args.oldNonHashed Set to true if oldPassword is sent as clear text (not recommended).
 * @param {Boolean} args.newNonHashed Set to true if newPassword is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateConfiguration = updateConfiguration;
var updateOwnPassword = req('conf/updateOwnPassword');
/**
 * Updates the identity record of the requesting client.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Object} args.properties The properties to apply to the identity.
 * @returns {void}
 */

exports.updateOwnPassword = updateOwnPassword;
var updateProfile = req('conf/updateProfile');
/**
 * Updates the credentials for the specified thing
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid
 * @param {String} args.id The id to set for the thing.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed Set to true if password is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateProfile = updateProfile;
var updateThingCredentials = req('conf/updateThingCredentials');
/**
 * Updates the credentials for the specified thing.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid The record id for the thing.
 * @param {String} args.id The id to set for the thing.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed  	Set to true if password is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateThingCredentials = updateThingCredentials;
var updateUser = req('conf/updateUser');
/**
 * Updates the credentials for the specified user.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid
 * @param {String} args.id The id to set for the user.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed Set to true if password is sent as clear text (not recommended).
 * @returns {}
 */

exports.updateUser = updateUser;
var updateUserCredentials = req('conf/updateUserCredentials'); // data-history

/**
 * Writes a batch directly to the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to write data history for.
 * @param {Array} args.data The historic data to write.
 * @param {Object} args.equidistance The distance between the data samples when writing equidistant data.
 * @param {String} args.timestamp The timestamp of the first sample when writing equidistant data.
 * @returns {void}
 */

exports.updateUserCredentials = updateUserCredentials;
var dataHistoryCreateBatch = req('data-history/createBatch');
/**
 * Fetches data from the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to read historic data for.
 * @param {String} args.from A lower limit for the timestamps of the returned records.
 * @param {String} args.to An upper limit for the timestamps of the returned records.
 * @param {Array<String>} args.projection The projection to use for the read operation.
 * @param {Number} args.limit The maximum number of records to return.
 * @param {Boolean} args.ascending Set to true to receive data with ascending timestamps.
 * @returns {Array} The requested records.
 */

exports.dataHistoryCreateBatch = dataHistoryCreateBatch;
var dataHistoryRead = req('data-history/read');
/**
 * Deletes data from the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to delete historic data for.
 * @param {String} args.from A lower limit for the timestamps of records to delete.
 * @param {String} args.to An upper limit for the timestamps of the records to delete.
 * @returns {Number} Number of records deleted.
 */

exports.dataHistoryRead = dataHistoryRead;
var dataHistoryDelete = req('data-history/delete'); // notification

/**
 * Read notifications.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.type
 * @param {Array<String>} args.rids
 * @param {Object} args.filter
 * @param {Number} args.skip
 * @param {Limit} args.limit
 * @param {Array<String>} args.projection
 * @param {Object} args.sort
 * @returns {Array} The requested notification(s).
 */

exports.dataHistoryDelete = dataHistoryDelete;
var notificationRead = req('notification/read'); // mailer

/**
 * Sends an email depending on the provided parameters.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.to The recipient mail addresses.
 * @param {String} args.subject The subject to set for the mail.
 * @param {String} args.text The pure text content to use as mail content.
 * @param {String} args.html The html content to use as mail content.
 * @returns {void}
 */

exports.notificationRead = notificationRead;
var mailerSend = req('mailer/send');
/**
 * Main function for subscribing to and getting historic data from a channel.
 * @func
 * @static
 * @param {object} options
 * @param {string} options.rid
 * @param {boolean} options.last If to include last value
 * @param {number} options.tail How many historic values to fetch
 * @param {number} options.ttl Time to live as seconds
 * @param {function} options.cb Callback (for one/each value)
 * @param {function} options.historyCb Callback for history batch
 * @param {boolean} options.noSub If not to subscribe
 * @param {string} options.path Extract a path from each message
 * @param {boolean} options.noTsToDate No Date conversion
 * @param {string[]} options.projection
 * @param {string} options.busChannel Raw channel (instead of rid)
 * @returns {function|undefined} Unsubscribe function if relevant
 */

exports.mailerSend = mailerSend;

var fromChannel = function fromChannel(_ref2) {
  var rid = _ref2.rid,
      last = _ref2.last,
      tail = _ref2.tail,
      ttl = _ref2.ttl,
      cb = _ref2.cb,
      historyCb = _ref2.historyCb,
      noSub = _ref2.noSub,
      path = _ref2.path,
      noTsToDate = _ref2.noTsToDate,
      projection = _ref2.projection,
      busChannel = _ref2.busChannel;
  if (rid === undefined && busChannel === undefined) return undefined;
  var fix = R.compose(R.when(function () {
    return path !== undefined;
  }, (0, _get["default"])(path)), R.when(function () {
    return !noTsToDate;
  }, _dmUtils.evolveTsToDate), _dmUtils.ensureTsV3);
  var callback = R.o(cb, fix);

  if (last || tail) {
    req('data-history/read', _objectSpread({
      channel: rid
    }, ttl ? {
      from: (0, _dmUtils.dateToTs)((0, _subSeconds["default"])(ttl)(new Date()))
    } : {}, {
      limit: tail || Number(last),
      projection: projection
    })).then(function (reply) {
      return historyCb ? historyCb(reply.reverse().map(fix)) : reply.reverse().forEach(callback);
    });
  }

  if (!noSub) {
    var channel = busChannel || ridToBusChannel(rid);
    sub(callback, channel);

    var unsubscribe = function unsubscribe() {
      return unsub(channel, callback);
    };

    return unsubscribe; // notify caller about a subscription made
  }

  return undefined;
};
/**
 * Get a channel's ChannelType record from a channel record.
 * @func
 * @static
 * @param {type} rid A channel record
 * @returns {Promise} A Promise of a type record
 */


exports.fromChannel = fromChannel;

var getChannelTypeFromChannel =
/*#__PURE__*/
function () {
  var _ref4 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(_ref3) {
    var id, _ref5, _ref6, type;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            id = _ref3.type;

            if (id) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt("return", undefined);

          case 3:
            _context2.next = 5;
            return readChannelType({
              rids: [],
              filter: ['=', 'id', id]
            });

          case 5:
            _ref5 = _context2.sent;
            _ref6 = _slicedToArray(_ref5, 1);
            type = _ref6[0];
            return _context2.abrupt("return", type);

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getChannelTypeFromChannel(_x2) {
    return _ref4.apply(this, arguments);
  };
}();
/**
 * Get a channel record and its channel type record (if any).
 * @func
 * @static
 * @param {type} rid A channel rid
 * @returns {Promise} A Promise of an object with the type record and the channel record.
 */


exports.getChannelTypeFromChannel = getChannelTypeFromChannel;

var getChannelAndTypeFromRid =
/*#__PURE__*/
function () {
  var _ref7 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(rid) {
    var _ref8, _ref9, channel, type;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return readChannel({
              rids: [rid]
            });

          case 2:
            _ref8 = _context3.sent;
            _ref9 = _slicedToArray(_ref8, 1);
            channel = _ref9[0];
            _context3.next = 7;
            return getChannelTypeFromChannel(channel);

          case 7:
            type = _context3.sent;
            return _context3.abrupt("return", channel ? {
              channel: channel,
              type: type
            } : undefined);

          case 9:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function getChannelAndTypeFromRid(_x3) {
    return _ref7.apply(this, arguments);
  };
}();

exports.getChannelAndTypeFromRid = getChannelAndTypeFromRid;

var getUnitFromChannel =
/*#__PURE__*/
function () {
  var _ref10 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4(channelRid) {
    var channelAndType, type, unit;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return getChannelAndTypeFromRid(channelRid);

          case 2:
            channelAndType = _context4.sent;

            if (channelAndType) {
              _context4.next = 5;
              break;
            }

            return _context4.abrupt("return", undefined);

          case 5:
            type = channelAndType.type;

            if (type) {
              _context4.next = 8;
              break;
            }

            return _context4.abrupt("return", undefined);

          case 8:
            unit = type.unit;
            return _context4.abrupt("return", unit);

          case 10:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function getUnitFromChannel(_x4) {
    return _ref10.apply(this, arguments);
  };
}();

exports.getUnitFromChannel = getUnitFromChannel;

var presenceFor = function presenceFor(_ref11) {
  var id = _ref11.id,
      cb = _ref11.cb,
      noSub = _ref11.noSub;
  if (id === undefined) return undefined;
  req('presence/listClients', {}).then(function (reply) {
    return cb(reply.includes(id));
  });

  if (!noSub) {
    var callback = R.o(cb, R.prop('login'));
    var channel = "presence/".concat(id);
    sub(callback, channel);

    var unsubscribe = function unsubscribe() {
      return unsub(channel, callback);
    };

    return unsubscribe; // notify caller about a subscription made
  }

  return undefined;
};

exports.presenceFor = presenceFor;
var reqEntityConf = R.curry(function (id, entityRid) {
  return readConfiguration(_objectSpread({
    entities: (0, _transforms.ensureArray)(entityRid),
    rids: []
  }, id ? {
    filter: ['=', 'id', id]
  } : {})).then(function (results) {
    return id && typeof entityRid === 'string' ? results[0] : results;
  });
});
exports.reqEntityConf = reqEntityConf;

var ensureEntityConf =
/*#__PURE__*/
function () {
  var _ref12 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5(id, entityRid, conf) {
    var result, newConf;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return reqEntityConf(id, entityRid);

          case 2:
            result = _context5.sent;

            if (!result) {
              _context5.next = 7;
              break;
            }

            _context5.next = 6;
            return updateConfiguration({
              rids: [result.rid],
              properties: conf
            });

          case 6:
            return _context5.abrupt("return", result);

          case 7:
            _context5.next = 9;
            return createConfiguration({
              id: id,
              properties: conf
            });

          case 9:
            newConf = _context5.sent;
            _context5.next = 12;
            return addConfigurationToEntity({
              rids: [entityRid],
              configurations: [newConf.rid]
            });

          case 12:
            return _context5.abrupt("return", newConf);

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function ensureEntityConf(_x5, _x6, _x7) {
    return _ref12.apply(this, arguments);
  };
}();

exports.ensureEntityConf = ensureEntityConf;

var entitiesConfigsMapper = function entitiesConfigsMapper(configIds) {
  return R.compose(R.chain(function (entityRid) {
    return R.map(function (id) {
      return {
        id: id,
        entityRid: entityRid
      };
    })(configIds);
  }), R.pluck('rid'));
};

var inflateConfMap = R.map(function (obj) {
  return reqEntityConf(obj.id, obj.entityRid).then(R.compose( // R.tap(console.log),
  R.mergeLeft(obj), R.objOf('config')));
});

var injectConfsInto = function injectConfsInto(entities) {
  return R.compose(R.values, R.reduce(function (enties, _ref13) {
    var config = _ref13.config,
        id = _ref13.id,
        entityRid = _ref13.entityRid;
    if (config && R.has(entityRid)(enties)) return R.evolve(_defineProperty({}, entityRid, (0, _transforms.ensureAndEvolveKey)({}, 'configurations', R.mergeLeft(_defineProperty({}, id, config)))))(enties);
    return enties;
  }, (0, _dmUtils.formatRecords)(entities)));
};
/**
 * DEPRECATED! Abstracted req call with support for configurationsToInclude from future.
 * @func
 * @static
 * @param {object} args The arguments for the call. Supports configurationsToInclude.
 * @returns {object} Collection (list) of entities read, or one entity for specific requests.
 */


var reqReadEntities =
/*#__PURE__*/
function () {
  var _ref14 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee6(rpc, args) {
    var _args$configurationsT, configurationsToInclude, rest, reply, entities, confsToRead, confRequests, configsWithRefs, result;

    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            console.warn('reqReadEntities is Deprecated. Entity configs should be read separately.'); // TODO: only config rids should be put in each asset's
            // 'configurations', and configs should then be fetched separately

            _args$configurationsT = args.configurationsToInclude, configurationsToInclude = _args$configurationsT === void 0 ? [] : _args$configurationsT, rest = _objectWithoutProperties(args, ["configurationsToInclude"]);
            _context6.next = 4;
            return req(rpc, rest);

          case 4:
            reply = _context6.sent;
            entities = (0, _transforms.ensureArray)(reply);
            confsToRead = entitiesConfigsMapper(configurationsToInclude)(entities); // console.log('confsToRead:', confsToRead);

            confRequests = inflateConfMap(confsToRead);
            _context6.next = 10;
            return Promise.all(confRequests);

          case 10:
            configsWithRefs = _context6.sent;
            // console.log('configsWithRefs (should be list):', configsWithRefs);
            result = injectConfsInto(entities)(configsWithRefs); // console.log('result:', result);

            return _context6.abrupt("return", Array.isArray(reply) ? result : R.prop(0, result));

          case 13:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function reqReadEntities(_x8, _x9) {
    return _ref14.apply(this, arguments);
  };
}();

exports.reqReadEntities = reqReadEntities;

var logout = function logout() {
  if (!_extendedDsClient.ds.client) return;

  _extendedDsClient.ds.client.off();

  _extendedDsClient.ds.client.close();
};
/**
 * Creates a connection to the backend server.
 * @func
 * @static
 * @param {string} serverAddress
 * @param {function} onUnexpectedError Callback triggered on general errors in the client.
 * @return {object} - An extended deepstream client
 */


exports.logout = logout;

var createConnection = function createConnection(serverAddress, onUnexpectedError) {
  console.log('createConnection:', serverAddress);
  var client = (0, _extendedDsClient["default"])(serverAddress);
  client.on('error', onUnexpectedError);
  return client;
};
/**
 * Hash a password (or other string)
 * @param {string} pw A password
 * @returns {string} A hash string
 */


var pwHash = function pwHash(pw) {
  return String((0, _sha["default"])(pw));
};
/**
 * INTERNAL helper function for logging in to an i4 server
 * @func
 * @static
 * @private
 * @param {object} client
 * @param {string} serverAddress
 * @param {string} id Client/user id
 * @param {string} password Probably hashed
 * @param {function} onConnectionError Callback invoked on a connection Error
 * @returns {object} An object with id, password and serverAddress
 */


exports.pwHash = pwHash;

var loginClient =
/*#__PURE__*/
function () {
  var _ref15 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee7(client, serverAddress, id, password, onConnectionError) {
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return client.p.login({
              id: id,
              password: password
            });

          case 2:
            client.on('connectionStateChanged', function (state) {
              // We need to set this only when we know that we got a working logged in connection
              console.log('CONNECTION STATE:', state);
              if (state === 'ERROR' && client.connectionState !== 'ERROR') onConnectionError();
              /* eslint-disable no-param-reassign */

              client.connectionState = state;
              /* eslint-enable no-param-reassign */
            });
            return _context7.abrupt("return", {
              id: id,
              password: password,
              serverAddress: serverAddress
            });

          case 4:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));

  return function loginClient(_x10, _x11, _x12, _x13, _x14) {
    return _ref15.apply(this, arguments);
  };
}();
/**
 * Function for logging in to an i4 server. Will use a singleton "global" client.
 * @param {string} serverAddress Endpoint to connect to
 * @param {string} id Client/user id
 * @param {string} password The password (probably hashed)
 * @param {function} onConnectionError Callback invoked on a connection Error
 * @param {function} onUnexpectedError Callback triggered on general errors in the client
 * @returns {type} Description
 */


exports.loginClient = loginClient;

var login =
/*#__PURE__*/
function () {
  var _ref16 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee8(serverAddress, id, password, onConnectionError, onUnexpectedError) {
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            if (_extendedDsClient.ds.client) logout();
            _extendedDsClient.ds.client = createConnection(serverAddress, onUnexpectedError);
            return _context8.abrupt("return", loginClient(_extendedDsClient.ds.client, serverAddress, id, password, onConnectionError));

          case 3:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));

  return function login(_x15, _x16, _x17, _x18, _x19) {
    return _ref16.apply(this, arguments);
  };
}();

exports.login = login;